; 
    include masm32rt.inc
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

CRTINIT	macro
 ALIGN 16
 IFDEF WIN
 ELSE
  if @Model eq FL
	;	 
	EXTERNDEF fpExitAddress : DWORD
	EXTERNDEF hStdIn : DWORD
	EXTERNDEF hStdOut : DWORD
	EXTERNDEF hStdErr : DWORD
	;	  
    pop fpExitAddress
	;	  
 	INVOKE GetStdHandle, STD_INPUT_HANDLE
	MOV hStdErr, EAX
	MOV hStdIn, EAX
 	INVOKE GetStdHandle, STD_OUTPUT_HANDLE
	MOV hStdOut, EAX
  Endif
 ENDIF
ENDM

RTB	macro cntr
 IFB <&cntr>
	ifb <&lang>
		.err Not supplyed language name
	else
		cntr = lang
	endif
 ENDIF
 IFIDNI <&cntr>,<CPP>
	echo Emulating C++
 ELSEIFIDNI <&cntr>,<DELPHI>
	echo Emulating Delphi
 ELSEIFIDNI <&cntr>,<C>
	echo Emulating C with standard runtime libraries
	CRTINIT
 ELSEIFIDNI <&cntr>,<PASCAL>
	echo Emulating procedural Pascal
 ELSEIFIDNI <&cntr>,<BASIC>
	echo Emulating procedural Basic
 ELSEIFIDNI <&cntr>,<CNRT>
	echo Emulating C without the runtime library
 ELSEIFIDNI <&cntr>,<ASM>
	echo Assembler program with runtime library
	CRTINIT
 ELSEIFIDNI <&cntr>,<STDCALL>
	echo Assembler program with runtime library
	CRTINIT
 ELSEIFIDNI <&cntr>,<ASMNRT>
	echo Assembler programming free
	EXITM
 ELSE
	echo Unknown programming - &cntr
 ENDIF
ENDM

  ; ------------------------------------------------------------------
  ; Feeling left out of it because you cannot produce bloated garbage
  ; like most compilers do ? Here is a simple solution so you can
  ; compete with the bloated size of compiler output, the BLOAT macro.
  ; Use this macro and you can tell your friends that you have learnt
  ; to write code like C++, Delphi or any other visual garbage generator
  ; ------------------------------------------------------------------

    bloat MACRO lang
      LOCAL cntr
      IFIDN <lang>,<CPP>
        echo Emulating C++
        cntr = 50000
      ELSEIFIDN <lang>,<DELPHI>
        echo Emulating Delphi
        cntr = 50000
      ELSEIFIDN <lang>,<C>
        echo Emulating C with standard runtime libraries
        cntr = 25000
      ELSEIFIDN <lang>,<PASCAL>
        echo Emulating procedural Pascal
        cntr = 20000
      ELSEIFIDN <lang>,<BASIC>
        echo Emulating procedural Basic
        cntr = 5000
      ELSEIFIDN <lang>,<CNRT>
        echo Emulating C without the runtime library
        cntr = 1000
      ELSEIFIDN <lang>,<ASM>
        EXITM
      ELSE
        echo "Please wait, this OP is slow"
        cntr = 100000
      ENDIF
      
      REPEAT cntr
        nop
      ENDM
      align 16
    ENDM

    .code

start:

    RTB asm
   
; 

    call main
    inkey
    exit

; 

main proc

    cls
    print "Hello World",13,10

    ret

main endp

; 

end start
